"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from clerk_backend_api.types import BaseModel
from clerk_backend_api.utils import FieldMetadata, QueryParamMetadata
from enum import Enum
from typing import Optional, TypedDict
from typing_extensions import Annotated, NotRequired


class ListInstanceOrganizationInvitationsQueryParamStatus(str, Enum):
    r"""Filter organization invitations based on their status"""
    PENDING = "pending"
    ACCEPTED = "accepted"
    REVOKED = "revoked"

class ListInstanceOrganizationInvitationsRequestTypedDict(TypedDict):
    limit: NotRequired[int]
    r"""Applies a limit to the number of results returned.
    Can be used for paginating the results together with `offset`.
    """
    offset: NotRequired[int]
    r"""Skip the first `offset` results when paginating.
    Needs to be an integer greater or equal to zero.
    To be used in conjunction with `limit`.
    """
    order_by: NotRequired[str]
    r"""Allows to return organization invitations in a particular order.
    At the moment, you can order the returned organization invitations either by their `created_at` or `email_address`.
    In order to specify the direction, you can use the `+/-` symbols prepended in the property to order by.
    For example, if you want organization invitations to be returned in descending order according to their `created_at` property, you can use `-created_at`.
    If you don't use `+` or `-`, then `+` is implied.
    Defaults to `-created_at`.
    """
    status: NotRequired[ListInstanceOrganizationInvitationsQueryParamStatus]
    r"""Filter organization invitations based on their status"""
    query: NotRequired[str]
    r"""Filter organization invitations based on their `email_address`"""
    

class ListInstanceOrganizationInvitationsRequest(BaseModel):
    limit: Annotated[Optional[int], FieldMetadata(query=QueryParamMetadata(style="form", explode=True))] = 10
    r"""Applies a limit to the number of results returned.
    Can be used for paginating the results together with `offset`.
    """
    offset: Annotated[Optional[int], FieldMetadata(query=QueryParamMetadata(style="form", explode=True))] = 0
    r"""Skip the first `offset` results when paginating.
    Needs to be an integer greater or equal to zero.
    To be used in conjunction with `limit`.
    """
    order_by: Annotated[Optional[str], FieldMetadata(query=QueryParamMetadata(style="form", explode=True))] = "-created_at"
    r"""Allows to return organization invitations in a particular order.
    At the moment, you can order the returned organization invitations either by their `created_at` or `email_address`.
    In order to specify the direction, you can use the `+/-` symbols prepended in the property to order by.
    For example, if you want organization invitations to be returned in descending order according to their `created_at` property, you can use `-created_at`.
    If you don't use `+` or `-`, then `+` is implied.
    Defaults to `-created_at`.
    """
    status: Annotated[Optional[ListInstanceOrganizationInvitationsQueryParamStatus], FieldMetadata(query=QueryParamMetadata(style="form", explode=True))] = None
    r"""Filter organization invitations based on their status"""
    query: Annotated[Optional[str], FieldMetadata(query=QueryParamMetadata(style="form", explode=True))] = None
    r"""Filter organization invitations based on their `email_address`"""
    
